from charms.reactive import when, when_not, set_flag
from charmhelpers.core.hookenv import (
    status_set,
    log,
    resource_get
)
from charmhelpers.core import hookenv
from charms.layer import snap
from charms.templating.jinja2 import render

@when_not('keycloak.installed')
def install_keycloak():
    """
         Install Keyclaok
         This will download a Keycloak snap package and install it.
    """
    status_set('maintenance', 'Installing Keycloak')
    snap.install('keycloak-standalone-spicule', channel="edge", devmode=True)
    hookenv.open_port(8080)
    status_set('waiting', 'Keycloak Installed')
    set_flag('keycloak.installed')

@when('mysql.available')
def configure_keycloak(mysql):
    context = {
        'mysql_address': mysql.host()+":"+str(mysql.port()),
        'mysql_user': mysql.user(),
        'mysql_password':mysql.password(),
        'mysql_database': mysql.database()
    }

    render('standalone_config_mysql.xml', '/var/snap/keycloak-standalone-spicule/current/configuration/standalone.xml', context)

